#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#if STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#else
#include <strings.h>
#endif

#include        "tof77.h"

#include "compilerApi.h"

void analyse5(SgStatement *);

void insertBlockAfterFirstStmt(SgStatement *current, SgStatement *where ,int list)
{
    SgStatement *lasts = list==1?where->childList1(0) : where->childList2(0) ;
    for ( int j=1; j< current->numberOfChildrenList1()-1 ; j++ )
    {
	SgStatement *tmps = current->childList1(j)->copyPtr();
	lasts->insertStmtAfter(*tmps,*where);
	lasts=tmps;
    }
}

SgExpression * cond_expr(SgExpression * var_ref, SgExpression * range_op)
{
   SgExpression * varcopy=var_ref->copyPtr();
   SgExpression * lhs=range_op->lhs()?range_op->lhs()->copyPtr():(SgExpression*)NULL;
   SgExpression * rhs=range_op->rhs()?range_op->rhs()->copyPtr():(SgExpression*)NULL;
   SgExpression * condition=NULL;

   if(range_op->variant()==RANGE_OP)  
     {
       if ((lhs != NULL) && (rhs==NULL))
         condition =&(*varcopy >= * lhs);
       if ((rhs != NULL) && (lhs==NULL))
         condition  =&(*varcopy <= * rhs);
       if ((rhs != NULL) && (lhs!=NULL))
         {
          SgExpression *var_ref1=&(*varcopy->copyPtr() >= * lhs);
          SgExpression *var_ref2=&(*varcopy->copyPtr() <= * rhs);
         condition =&(*var_ref1 && *var_ref2); 
          }
                
     }
  else  
       {   if(varcopy->type()->variant()==T_BOOL)
               condition=&SgEqvOp(*varcopy,  *range_op->copyPtr());
           else    
               condition=&SgEqOp(*varcopy,  *range_op->copyPtr());
       }
  return condition;
}

void trans_case(SgStatement * s)
{
    int org_numberOfChildren=s->numberOfChildrenList1();
    SgStatement * * children=new SgStatement * [org_numberOfChildren];

    int i;
    SgExpression * var_ref=s->expr(0);
    SgIfStmt * if_stmt=NULL;
    SgElseIfStmt * last_if=NULL;
    SgStatement * default_stmt=NULL;

    for(i=0;i<org_numberOfChildren;i++)
      children[i]=s->childList1(i);

    for(i=0; i<org_numberOfChildren; i++)
      {
         switch(children[i]->variant()) {
         case CASE_NODE:
              switch(children[i]->expr(0)->variant()) {
              case RANGE_LIST:
                   {
                    SgExpression * range_op=children[i]->expr(0)->lhs();

                    SgExpression * condition=NULL;
                    for( SgExpression * expr=children[i]->expr(0); expr; expr=expr->rhs())
                    {
                      SgExpression *temp_condition=cond_expr(var_ref,expr->lhs());
                      condition=condition==NULL?temp_condition:&(*condition || *temp_condition);
                    }
                        
                    if(if_stmt==NULL)
                      { SgIfStmt * temp_stmt=new SgIfStmt(*condition,*children[i]->childList1(0)->copyPtr(),NULL);  
		        insertBlockAfterFirstStmt(children[i], temp_stmt, 1);
                        s->insertStmtAfter(*temp_stmt,*s->controlParent());
                        analyse5(temp_stmt);
                        if_stmt=temp_stmt;
                        last_if=(SgElseIfStmt *)temp_stmt;
                      }
                    else
                     {
                   	 SgElseIfStmt *temp_stmt=new SgElseIfStmt(*condition,*children[i]->childList1(0)->copyPtr() ,NULL);
		   	 insertBlockAfterFirstStmt(children[i], temp_stmt, 1);
                         last_if->replaceFalseBody(*temp_stmt);
                   	 analyse5(temp_stmt);
                         last_if=temp_stmt; 
                      }                     
                    break;
                    }
              case DEFAULT:
                    default_stmt=children[i]; 
                    break;
              }
              break;
         }
      }

   if(default_stmt) 
   {    
     if( last_if !=NULL)
       {  
        last_if->replaceFalseBody(default_stmt->childList1(0)->copy()); 
	insertBlockAfterFirstStmt(default_stmt, last_if, 2);
        analyse5(last_if); 
       }
     else
       for ( int j= default_stmt->numberOfChildrenList1()-2 ; j>=0;j-- )
       {
	SgStatement *tmps = default_stmt->childList1(j)->copyPtr();
	s->insertStmtAfter(*tmps,*s->controlParent());
        analyse5(tmps);
       }
   }
   s->deleteStmt();
}

void analyse5(SgStatement * s)
{
  switch(s->variant())
  {
    case GLOBAL:
      {
         int org_numberOfChildren=s->numberOfChildrenList1();
         SgStatement * * children=new SgStatement * [org_numberOfChildren];

         int i;

         for(i=0;i<org_numberOfChildren;i++)
             children[i]=s->childList1(i);
         for(i=0;i<org_numberOfChildren;i++)
             analyse5(children[i]);

        delete [] children;

        break;
      };

 case PROG_HEDR:
      { 
         int org_numberOfChildren=s->numberOfChildrenList1();
         SgStatement * * children=new SgStatement * [org_numberOfChildren];

         int i;

         for(i=0;i<org_numberOfChildren;i++)
             children[i]=s->childList1(i); 

         in_main_program=on;

         for(i=0;i<org_numberOfChildren;i++)
             analyse5(children[i]);

         delete [] children;

         in_main_program=off;
  
         break;
       };

   case PROC_HEDR:
      {
        SgProcHedrStmt * prochedr=(SgProcHedrStmt *)s;
        int org_numberOfChildren=s->numberOfChildrenList1();
        SgStatement * * children=new SgStatement * [org_numberOfChildren];

        int i;

        for(i=0;i<org_numberOfChildren;i++)
            children[i]=s->childList1(i);

        in_procedure=on;

        for(i=0;i<org_numberOfChildren;i++)
             analyse5(children[i]);
     
        delete [] children;

        in_procedure=off;

        break;
      };
   case FUNC_HEDR:
      {
         SgFuncHedrStmt * prochedr=(SgFuncHedrStmt *)s;
         int org_numberOfChildren=s->numberOfChildrenList1();
         SgStatement * * children=new SgStatement * [org_numberOfChildren];

         int i;

         for(i=0;i<org_numberOfChildren;i++)
              children[i]=s->childList1(i);

         in_function=on;

         for(i=0;i<org_numberOfChildren;i++)
             analyse5(children[i]);

         delete [] children;

         in_function=off;

         break;
      };  
 
  case FOR_NODE:
  case DO_WHILE_NODE:
  case LOGIF_NODE:
  case ELSEIF_NODE:
  case LOGIF_STMT:
    {
      int org_numberOfChildren1=s->numberOfChildrenList1();

      SgStatement * * children1 = new SgStatement * [org_numberOfChildren1];

      int org_numberOfChildren2=s->numberOfChildrenList2();

      SgStatement * * children2 = new SgStatement * [org_numberOfChildren2];

      int i;

      for (i=0; i<org_numberOfChildren1; i++)
        children1[i]=s->childList1(i);

      for (i=0; i<org_numberOfChildren1; i++)
        analyse5(children1[i]);

       delete [] children1;

      for (i=0; i<org_numberOfChildren2; i++)
        children2[i]=s->childList2(i);

      for (i=0; i<org_numberOfChildren2; i++)
        analyse5(children2[i]);
      
      delete [] children2;

      break;

    }

    case SWITCH_NODE:
        {
          trans_case(s);
          break;
        }
 }
                    
}
